"use strict";

module.exports = function stringOperation({ textMode, characterIndex, input, operation }) {
	let { string } = operation;

	if (!textMode) {
		throw new Error(`Cannot use string literal rules in binary parsing mode`);
	} else if (currentIndex + string.length > input.length) {
		return NotEnoughInput;
	} else if (input.slice(characterIndex, characterIndex + string.length) === operation.string) {
		return { value: string, consumedCharacters: string.length };
	} else {
		return NoMatch;
	}
};
