"use strict";

const { zeroOrMore } = require("../../operations");
const makeNewlineVariants = require("../lines/_make-newline-variants");
const line = require("./line");

module.exports = makeNewlineVariants((Newline, type) => {
	return function spacedLine(strings, ... parsers) {
		return function* SpacedLineTemplate() {
			// NOTE: This does *not* allow leading newlines, because a line template may start parsing in the middle of an existing line, and allowing leading newlines would break the intended behaviour of only parsing that same line
			let result = yield line[type](strings, ... parsers);
			yield zeroOrMore(Newline);
			return result;
		}
	};
});
